/**
 * Created by MeePwn
 * https://github.com/maybewaityou
 *
 * description:
 *
 */
import { Observable as RxObservable } from 'rxjs';

declare function log(message?: any, ...optionalParams: any[]): any;
declare function toString(value: any, replacer?: (key: string, value: any) => any, space?: string | number): string;
declare function toJSON(text: string, reviver?: (key: any, value: any) => any): any;

declare function toPromise(observableFunc: any, ...args: any[]);
declare function deepClone(values: any): any;
declare function isEmptyObject(obj: object): boolean;
declare function randomNum(min: number, max: number): number;

declare const BaseObject: any;
declare class Observable<T> extends BaseObject<T> {}

// declare class Observable<T> extends RxObservable<T> {}

declare class Validator {
  /**
   * 工厂方法
   */
  public static create(config: any, types: any);

  /* 所有可用的检查 */
  public types: any;
  /* 当前验证会话中的错误信息 */
  public messages: any[];
  /* 当前验证配置 名称: 验证类型 */
  public config: any;

  public constructor(config: any, types: any);

  public hasErrors(): boolean;
  public validate(data: any): boolean;
  public asyncValidate(data: any): boolean;
}

declare interface INetworkClient {
  asyncObserve: (url: string, params?: any) => Observable<any>;
  asyncRequest: (url: string, params?: any) => Promise<Response>;
}

declare interface IRequestParams {
  url: string;
  params: any;
}

declare interface INetworkConfig {
  timeout?: number;
  headers?: (params: any) => object;
  credentials?: 'omit' | 'same-origin' | 'include';
  mode?: 'navigate' | 'same-origin' | 'no-cors' | 'cors';
  prepare?: (requestParams: IRequestParams) => any;
  checkStatus?: (response: Response) => any;
  parseJSON?: (response: Response) => any;
  handleResponse?: (response: any, resolve: any, reject: any, requestParams: IRequestParams) => any;
  handleError?: (error: any, reject: any, requestParams: IRequestParams) => any;
}

declare class NetworkClient implements INetworkClient {
  public static getInstance(): NetworkClient;
  public setConfig: (config: INetworkConfig) => NetworkClient;
  public asyncObserve: (url: string, params?: any) => Observable<any>;
  public asyncRequest: (url: string, params?: any) => Promise<Response>;
  private constructor();
}

type genericExceptionHandler = (error: any, params?: any) => any;

declare interface IExtra {
  originalError?: Error;
  location?: string;
}

declare class Exception extends Error {
  public name: string;
  public message: string;
  public extra?: IExtra;
  public remedy?: genericExceptionHandler;

  constructor(name: string, message: string, extra?: IExtra, remedy?: genericExceptionHandler);
}

declare function throws(exception: Exception): any;
declare function throwException(name: string, message: string, extra?: IExtra, remedy?: genericExceptionHandler): any;
