'use strict';

Object.defineProperty(exports, '__esModule', { value: true });

var rxjs = require('rxjs');

function log(message) {
  var _console;

  for (var _len = arguments.length, optionalParams = new Array(_len > 1 ? _len - 1 : 0), _key = 1; _key < _len; _key++) {
    optionalParams[_key - 1] = arguments[_key];
  }

  (_console = console).log.apply(_console, [message].concat(optionalParams));
}

function toString(value, replacer, space) {
  return JSON.stringify(value, replacer, space);
}
function toJSON(text, reviver) {
  return JSON.parse(text, reviver);
}

function _typeof(obj) {
  if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") {
    _typeof = function (obj) {
      return typeof obj;
    };
  } else {
    _typeof = function (obj) {
      return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj;
    };
  }

  return _typeof(obj);
}

function asyncGeneratorStep(gen, resolve, reject, _next, _throw, key, arg) {
  try {
    var info = gen[key](arg);
    var value = info.value;
  } catch (error) {
    reject(error);
    return;
  }

  if (info.done) {
    resolve(value);
  } else {
    Promise.resolve(value).then(_next, _throw);
  }
}

function _asyncToGenerator(fn) {
  return function () {
    var self = this,
        args = arguments;
    return new Promise(function (resolve, reject) {
      var gen = fn.apply(self, args);

      function _next(value) {
        asyncGeneratorStep(gen, resolve, reject, _next, _throw, "next", value);
      }

      function _throw(err) {
        asyncGeneratorStep(gen, resolve, reject, _next, _throw, "throw", err);
      }

      _next(undefined);
    });
  };
}

function _classCallCheck(instance, Constructor) {
  if (!(instance instanceof Constructor)) {
    throw new TypeError("Cannot call a class as a function");
  }
}

function _defineProperties(target, props) {
  for (var i = 0; i < props.length; i++) {
    var descriptor = props[i];
    descriptor.enumerable = descriptor.enumerable || false;
    descriptor.configurable = true;
    if ("value" in descriptor) descriptor.writable = true;
    Object.defineProperty(target, descriptor.key, descriptor);
  }
}

function _createClass(Constructor, protoProps, staticProps) {
  if (protoProps) _defineProperties(Constructor.prototype, protoProps);
  if (staticProps) _defineProperties(Constructor, staticProps);
  return Constructor;
}

function _inherits(subClass, superClass) {
  if (typeof superClass !== "function" && superClass !== null) {
    throw new TypeError("Super expression must either be null or a function");
  }

  subClass.prototype = Object.create(superClass && superClass.prototype, {
    constructor: {
      value: subClass,
      writable: true,
      configurable: true
    }
  });
  if (superClass) _setPrototypeOf(subClass, superClass);
}

function _getPrototypeOf(o) {
  _getPrototypeOf = Object.setPrototypeOf ? Object.getPrototypeOf : function _getPrototypeOf(o) {
    return o.__proto__ || Object.getPrototypeOf(o);
  };
  return _getPrototypeOf(o);
}

function _setPrototypeOf(o, p) {
  _setPrototypeOf = Object.setPrototypeOf || function _setPrototypeOf(o, p) {
    o.__proto__ = p;
    return o;
  };

  return _setPrototypeOf(o, p);
}

function isNativeReflectConstruct() {
  if (typeof Reflect === "undefined" || !Reflect.construct) return false;
  if (Reflect.construct.sham) return false;
  if (typeof Proxy === "function") return true;

  try {
    Date.prototype.toString.call(Reflect.construct(Date, [], function () {}));
    return true;
  } catch (e) {
    return false;
  }
}

function _construct(Parent, args, Class) {
  if (isNativeReflectConstruct()) {
    _construct = Reflect.construct;
  } else {
    _construct = function _construct(Parent, args, Class) {
      var a = [null];
      a.push.apply(a, args);
      var Constructor = Function.bind.apply(Parent, a);
      var instance = new Constructor();
      if (Class) _setPrototypeOf(instance, Class.prototype);
      return instance;
    };
  }

  return _construct.apply(null, arguments);
}

function _isNativeFunction(fn) {
  return Function.toString.call(fn).indexOf("[native code]") !== -1;
}

function _wrapNativeSuper(Class) {
  var _cache = typeof Map === "function" ? new Map() : undefined;

  _wrapNativeSuper = function _wrapNativeSuper(Class) {
    if (Class === null || !_isNativeFunction(Class)) return Class;

    if (typeof Class !== "function") {
      throw new TypeError("Super expression must either be null or a function");
    }

    if (typeof _cache !== "undefined") {
      if (_cache.has(Class)) return _cache.get(Class);

      _cache.set(Class, Wrapper);
    }

    function Wrapper() {
      return _construct(Class, arguments, _getPrototypeOf(this).constructor);
    }

    Wrapper.prototype = Object.create(Class.prototype, {
      constructor: {
        value: Wrapper,
        enumerable: false,
        writable: true,
        configurable: true
      }
    });
    return _setPrototypeOf(Wrapper, Class);
  };

  return _wrapNativeSuper(Class);
}

function _assertThisInitialized(self) {
  if (self === void 0) {
    throw new ReferenceError("this hasn't been initialised - super() hasn't been called");
  }

  return self;
}

function _possibleConstructorReturn(self, call) {
  if (call && (typeof call === "object" || typeof call === "function")) {
    return call;
  }

  return _assertThisInitialized(self);
}

var networkConfig = {
  timeout: 30 * 1000,
  checkStatus: checkStatus,
  parseJSON: parseJSON,
  headers: headers
};
var NetworkClient =
/*#__PURE__*/
function () {
  _createClass(NetworkClient, null, [{
    key: "getInstance",
    value: function getInstance() {
      if (!NetworkClient.instance) {
        NetworkClient.instance = new NetworkClient();
      }

      return NetworkClient.instance;
    }
  }]);

  function NetworkClient() {
    _classCallCheck(this, NetworkClient);
  }

  _createClass(NetworkClient, [{
    key: "setConfig",
    value: function setConfig(config) {
      Object.assign(networkConfig, config);
      return this;
    }
  }, {
    key: "asyncObserve",
    value: function asyncObserve(url, params) {
      return rxjs.Observable.create(function (subscriber) {
        fetchData(url, params).then(function (response) {
          subscriber.next(response);
          subscriber.complete();
        }).catch(function (error) {
          subscriber.error(error);
        });
      });
    }
  }, {
    key: "asyncRequest",
    value: function asyncRequest(url, params) {
      return fetchData(url, params);
    }
  }]);

  return NetworkClient;
}();

function fetchData(subURL) {
  var params = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : {};
  var requestParams = {
    url: subURL,
    params: params
  };

  if (networkConfig.prepare) {
    requestParams = networkConfig.prepare(requestParams);
  }

  var meta = requestParams.params.meta || {};
  var method = meta.method || 'POST';
  delete requestParams.params.meta;
  var timeoutAction;
  setTimeout(function () {
    timeoutAction();
  }, networkConfig.timeout);
  return Promise.race([new Promise(function (resolve, reject) {
    fetch(requestParams.url, {
      method: method,
      headers: networkConfig.headers(params),
      credentials: networkConfig.credentials,
      mode: networkConfig.mode,
      body: method.toUpperCase() === 'POST' ? JSON.stringify(requestParams.params) : undefined
    }).then(networkConfig.checkStatus).then(networkConfig.parseJSON).then(function (response) {
      networkConfig.handleResponse ? networkConfig.handleResponse(response, resolve, reject, {
        url: requestParams.url,
        params: requestParams.params
      }) : resolve(response);
    }).catch(function (error) {
      networkConfig.handleError ? networkConfig.handleError(error, reject, {
        url: requestParams.url,
        params: requestParams.params
      }) : reject({
        errorMessage: error.message,
        errorStack: error.stack
      });
    });
  }), new Promise(function (resolve, reject) {
    timeoutAction = function timeoutAction() {
      reject(new Error('network request timeout.'));
    };
  })]);
}

function headers(params) {
  return {
    'Content-Type': 'application/json'
  };
}

function checkStatus(response) {
  if (response.status >= 200 && response.status < 400) {
    return response;
  } else {
    var error = new Error(response.statusText);
    error.response = response;
    throw error;
  }
}

function parseJSON(response) {
  return response.json();
}

var Validator =
/*#__PURE__*/
function () {
  function Validator(config, types) {
    _classCallCheck(this, Validator);

    this.messages = [];
    this.config = config;
    this.types = types;
  }

  _createClass(Validator, [{
    key: "hasErrors",
    value: function hasErrors() {
      return this.messages.length !== 0;
    }
  }, {
    key: "validate",
    value: function validate(data) {
      var _this = this;

      var _loop = function _loop(i) {
        if (data.hasOwnProperty(i)) {
          var type = _this.config[i];
          var checker = _this.types[type];

          if (!type) {
            return "continue";
          }

          if (!checker) {
            throw {
              name: 'ValidationError',
              message: 'No handler to validate type ' + type
            };
          }

          var result = checker.validate(data[i]);

          if (!result) {
            var msg = typeof checker.instructions === 'string' ? checker.instructions : checker.instructions(i);

            _this.messages.push({
              field: i,
              instructions: msg
            });
          } else {
            var index = _this.messages.findIndex(function (item) {
              return item.field === i;
            });

            if (index !== -1) {
              _this.messages.splice(index, 1);
            }
          }
        }
      };

      for (var i in data) {
        var _ret = _loop(i);

        if (_ret === "continue") continue;
      }

      return this.hasErrors();
    }
  }, {
    key: "asyncValidate",
    value: function () {
      var _asyncValidate = _asyncToGenerator(
      /*#__PURE__*/
      regeneratorRuntime.mark(function _callee(data) {
        var _this2 = this;

        var _loop2, i, _ret2;

        return regeneratorRuntime.wrap(function _callee$(_context2) {
          while (1) {
            switch (_context2.prev = _context2.next) {
              case 0:
                _loop2 =
                /*#__PURE__*/
                regeneratorRuntime.mark(function _loop2(i) {
                  var type, checker, result, msg, index;
                  return regeneratorRuntime.wrap(function _loop2$(_context) {
                    while (1) {
                      switch (_context.prev = _context.next) {
                        case 0:
                          if (!data.hasOwnProperty(i)) {
                            _context.next = 11;
                            break;
                          }

                          type = _this2.config[i];
                          checker = _this2.types[type];

                          if (type) {
                            _context.next = 5;
                            break;
                          }

                          return _context.abrupt("return", "continue");

                        case 5:
                          if (checker) {
                            _context.next = 7;
                            break;
                          }

                          throw {
                            name: 'ValidationError',
                            message: 'No handler to asyncValidate type ' + type
                          };

                        case 7:
                          _context.next = 9;
                          return checker.asyncValidate(data[i]);

                        case 9:
                          result = _context.sent;

                          if (result) {
                            msg = typeof checker.instructions === 'string' ? checker.instructions : checker.instructions(result, i);

                            _this2.messages.push({
                              field: i,
                              instructions: msg
                            });
                          } else {
                            index = _this2.messages.findIndex(function (item) {
                              return item.field === i;
                            });

                            if (index !== -1) {
                              _this2.messages.splice(index, 1);
                            }
                          }

                        case 11:
                        case "end":
                          return _context.stop();
                      }
                    }
                  }, _loop2, this);
                });
                _context2.t0 = regeneratorRuntime.keys(data);

              case 2:
                if ((_context2.t1 = _context2.t0()).done) {
                  _context2.next = 10;
                  break;
                }

                i = _context2.t1.value;
                return _context2.delegateYield(_loop2(i), "t2", 5);

              case 5:
                _ret2 = _context2.t2;

                if (!(_ret2 === "continue")) {
                  _context2.next = 8;
                  break;
                }

                return _context2.abrupt("continue", 2);

              case 8:
                _context2.next = 2;
                break;

              case 10:
                return _context2.abrupt("return", this.hasErrors());

              case 11:
              case "end":
                return _context2.stop();
            }
          }
        }, _callee, this);
      }));

      return function asyncValidate(_x) {
        return _asyncValidate.apply(this, arguments);
      };
    }()
  }], [{
    key: "create",
    value: function create(config, types) {
      return new Validator(config, types);
    }
  }]);

  return Validator;
}();

function deepClone(values) {
  var copy;

  if (null == values || 'object' !== _typeof(values)) {
    return values;
  }

  if (values instanceof Date) {
    copy = new Date();
    copy.setTime(values.getTime());
    return copy;
  }

  if (values instanceof Array) {
    copy = [];

    for (var i = 0, len = values.length; i < len; i++) {
      copy[i] = deepClone(values[i]);
    }

    return copy;
  }

  if (values instanceof Object) {
    copy = {};

    for (var attr in values) {
      if (values.hasOwnProperty(attr)) {
        copy[attr] = deepClone(values[attr]);
      }
    }

    return copy;
  }

  throw new Error('Unable to copy values! Its type isn\'t supported.');
}
function isEmptyObject(obj) {
  return !Object.keys(obj).length;
}
function randomNum(min, max) {
  return Math.floor(min + Math.random() * (max - min));
}

function toPromise(observableFunc) {
  for (var _len = arguments.length, args = new Array(_len > 1 ? _len - 1 : 0), _key = 1; _key < _len; _key++) {
    args[_key - 1] = arguments[_key];
  }

  return new Promise(function (resolve, reject) {
    observableFunc.apply(void 0, args).subscribe(resolve, reject);
  });
}

var Exception =
/*#__PURE__*/
function (_Error) {
  _inherits(Exception, _Error);

  function Exception(name, message, extra, remedy) {
    var _this;

    _classCallCheck(this, Exception);

    _this = _possibleConstructorReturn(this, _getPrototypeOf(Exception).call(this, name));
    _this.name = name;
    _this.message = message;
    _this.extra = extra;
    _this.remedy = remedy;
    _this.description = JSON.stringify({
      name: name,
      message: message,
      extra: extra,
      remedy: remedy
    });
    return _this;
  }

  return Exception;
}(_wrapNativeSuper(Error));
function throws(exception) {
  throw exception;
}
function throwException(name, message, extra, remedy) {
  throw new Exception(name, message, extra, remedy);
}

exports.Observable = rxjs.Observable;
exports.log = log;
exports.toString = toString;
exports.toJSON = toJSON;
exports.NetworkClient = NetworkClient;
exports.toPromise = toPromise;
exports.Validator = Validator;
exports.deepClone = deepClone;
exports.isEmptyObject = isEmptyObject;
exports.randomNum = randomNum;
exports.Exception = Exception;
exports.throws = throws;
exports.throwException = throwException;
