/**
 * Created by MeePwn
 * https://github.com/maybewaityou
 *
 * @flow
 *
 * description:
 *
 */
import json from 'rollup-plugin-json';
import resolve from 'rollup-plugin-node-resolve';
import commonjs from 'rollup-plugin-commonjs';
import babel from 'rollup-plugin-babel';
import typescript from 'rollup-plugin-typescript';
import tsConfigPaths from 'rollup-plugin-ts-paths';
import alias from 'rollup-plugin-alias';
import { uglify } from "rollup-plugin-uglify";

import pkg from './package.json';

const umdModuleName = pkg.name.replace(/mario-/g, '');

export default {
  input: 'build/index.js',
  // 'amd', 'cjs', 'system', 'esm', 'iife' or 'umd'
  output: [
    { file: pkg.main, format: 'cjs' },
    { file: pkg.module, format: 'esm' },
    {
      file: pkg.browser, format: 'umd', name: umdModuleName, globals: {
        'rxjs': 'rxjs',
      },
    },
  ],
  plugins: [
    json(),
    alias({
      resolve: ['.tsx', '.ts', '.jsx', '.js', '.json'],
    }),
    resolve({
      jsnext: true,
      module: true,
      main: true,
      browser: true
    }),
    tsConfigPaths(),
    typescript(),
    commonjs(),
    babel({
      exclude: 'node_modules/**',
    }),
    // uglify(),
  ],
  external: [
    'rxjs',
    'rxjs-compat',
  ]
};
